/*
* Copyright (C) 2007-2009, CompHEP Collaboration
* Author: Slava Bunichev
* ------------------------------------------------------
*/
#include <stdio.h>
#include <ctype.h>
#include <string.h>

#include "service2/include/chep_limits.h"
#include "service2/include/files.h"
#include "service2/include/unix_utils.h"
#include "service2/include/tptcmac.h"
#include "service2/include/syst.h"
#include "chep_crt/include/chep_crt.h"

#include "roothisto.h"

static void
readtext (char *fname)
{
  FILE *txt;

  trim (fname);
  txt = fopen (fname, "r");
  if (txt == NULL)
    {
      warnanykey (10, 10, " File not found ");
      return;
    }
  showtext (28, 10, 70, 15, "", txt);
  fclose (txt);
}


static int
graphcolor (int first)
{
  int color;

  if (first == 1)
    color = 4;
  if (first == 2)
    color = 2;
  if (first == 3)
    color = 3;
  if (first == 4)
    color = 6;
  if (first == 5)
    color = 7;
  if (first == 6)
    color = 9;
  if (first == 7)
    color = 6;
  if (first == 8)
    color = 8;
  if (first == 9)
    color = 3;
  if (first == 10)
    color = 1;
  if (first == 11)
    color = 2;
  if (first == 12)
    color = 4;
  if (first == 13)
    color = 5;
  if (first == 14)
    color = 8;
  if (first == 15)
    color = 9;

  if (first > 15)
    color = 1;

  return (color);
}


static int
graphstyle (int first)
{
  int style;

  if (first == 1)
    style = 1;
  if (first == 2)
    style = 2;
  if (first == 3)
    style = 3;
  if (first == 4)
    style = 4;

  if (first == 5)
    style = 1;
  if (first == 6)
    style = 2;
  if (first == 7)
    style = 3;
  if (first == 8)
    style = 4;

  if (first == 9)
    style = 1;
  if (first == 10)
    style = 2;
  if (first == 11)
    style = 3;
  if (first == 12)
    style = 4;

  if (first == 13)
    style = 1;
  if (first == 14)
    style = 2;
  if (first == 15)
    style = 3;

  if (first > 15)
    style = 1;

  return (style);
}


static void
graph_identity (FILE * outfile, int first)
{
  if (first == 1)
    f_printf (outfile, "//solid, light blue\n");
  if (first == 2)
    f_printf (outfile, "//dashed, light red\n");
  if (first == 3)
    f_printf (outfile, "//doted, dark green\n");
  if (first == 4)
    f_printf (outfile, "//dots and dashes, dark magenta\n");

  if (first == 5)
    f_printf (outfile, "//solid, dark green and blue\n");
  if (first == 6)
    f_printf (outfile, "//dashed, medium blue\n");
  if (first == 7)
    f_printf (outfile, "//doted, light magenta\n");
  if (first == 8)
    f_printf (outfile, "//dots and dashes, medium green\n");

  if (first == 9)
    f_printf (outfile, "//solid, light green\n");
  if (first == 10)
    f_printf (outfile, "//dashed, grey\n");
  if (first == 11)
    f_printf (outfile, "//doted, dark red\n");
  if (first == 12)
    f_printf (outfile, "//dots and dashes, dark blue\n");

  if (first == 13)
    f_printf (outfile, "//solid, dark yellow\n");
  if (first == 14)
    f_printf (outfile, "//dashed, very dark green\n");
  if (first == 15)
    f_printf (outfile, "//doted, very dark blue\n");

  if (first > 15)
    f_printf (outfile, "//solid, black\n");
}

static void
writeroothist (char *menustr, int numstring)
{
  int i, k;
  int combine = 0;
  int dim;
  int old_dim;
  int first = 1;
  int color;
  int style;
  char c;
  char old_xstr[50] = { 0 };
  char upstr[50] = { 0 };
  char x_str[50] = { 0 };
  char y_str[50] = { 0 };
  double old_xMin;
  double old_xMax;
  double xMin, xMax, yMin, yMax;
  double dX;
  double totYMin = 0, totYMax = 0;

  char xaxistitle[128];
  char yaxistitle[128];
  char infname[STRSIZ];
  midstr outname;
  midstr outname_C;
  FILE *rf;

  nextFileName (outname, "combine_", ".C");
  strcpy (outname_C, outname);
  strcat (outname_C, ".C");

  first = 1;
  for (i = 1; i <= numstring; i++)
    {
      sprintf (infname, "%.14s", menustr + i * 15 - 14);
      trim (infname);
      if (menustr[i * 15] == '+')
	{
	  FILE *infile = fopen (infname, "r");
	  if (infile == NULL)
	    {
	      warnanykey (10, 10, " File not found ");
	      return;
	    }

	  k = 0;
	  while ((c = getc (infile)) != '\n')
	    {
	      upstr[k] = c;
	      k++;
	    }
	  k = 0;
	  while ((c = getc (infile)) != '\n')
	    {
	      x_str[k] = c;
	      k++;
	    }
	  fscanf (infile, "//X from %le to %le N_bins= %d\n", &xMin, &xMax, &dim);
	  k = 0;
	  while ((c = getc (infile)) != '\n')
	    {
	      y_str[k] = c;
	      k++;
	    }
	  fscanf (infile, "//Y from %le to %le", &yMin, &yMax);
	  fscanf (infile, "//combine= %d", &combine);

	  if (first != 1)
	    {
	      if (combine != 0)
		{
		  warnanykey (10, 10, " Combined distribution ");
		  fclose (infile);
		  return;
		}
	      if (strncmp (x_str, old_xstr, 2) != 0)
		{
		  warnanykey (10, 10, " Different functions ");
		  fclose (infile);
		  return;
		}

	      if (xMin != old_xMin || xMax != old_xMax)
		{
		  warnanykey (10, 10, " Different X-range ");
		  fclose (infile);
		  return;
		}
	      if (dim != old_dim)
		{
		  warnanykey (10, 10, " Different binning ");
		  fclose (infile);
		  return;
		}
	    }
	  fclose (infile);

	  if (first == 1)
	    {
	      totYMin = yMin;
	      totYMax = yMax;
	    }

	  if (yMin < totYMin)
	    totYMin = yMin;
	  if (yMax > totYMax)
	    totYMax = yMax;

	  strcpy (old_xstr, x_str);

	  for (k = 0; k < 50; k++)
	    {
	      upstr[k] = 0;
	      x_str[k] = 0;
	      y_str[k] = 0;
	    }

	  old_xMin = xMin;
	  old_xMax = xMax;
	  old_dim = dim;
	  first++;
	}
    }

  rf = fopen (outname_C, "w");
  if (NULL == rf)
    {
      messanykey (10, 12, scat ("Error! I can not open the file\n%s", outname_C));
      return;
    }

  first = 1;
  for (i = 1; i <= numstring; i++)
    {
      sprintf (infname, "%.14s", menustr + i * 15 - 14);
      trim (infname);
      if (menustr[i * 15] == '+')
	{
	  FILE *infile = fopen (infname, "r");
	  k = 0;
	  while ((c = getc (infile)) != '\n')
	    {
	      upstr[k] = c;
	      k++;
	    }
	  k = 0;
	  while ((c = getc (infile)) != '\n')
	    {
	      x_str[k] = c;
	      k++;
	    }
	  fscanf (infile, "//X from %le to %le N_bins= %d\n", &xMin,
		  &xMax, &dim);
	  k = 0;
	  while ((c = getc (infile)) != '\n')
	    {
	      y_str[k] = c;
	      k++;
	    }
	  fscanf (infile, "//Y from %le to %le", &yMin, &yMax);
	  fscanf (infile, "//combine= %d", &combine);
	  fclose (infile);

	  if (first == 1)
	    {
	      f_printf (rf, "%s\n", upstr);
	      f_printf (rf, "%s\n", x_str);
	      f_printf (rf, "//X from %e to %e N_bins= %d\n", xMin, xMax, dim);
	      f_printf (rf, "%s\n", y_str);
	      f_printf (rf, "//Y from %e to %e\n", yMin, yMax);
	      f_printf (rf, "//combine= 1\n");
	    }
	  else
	    {
	      f_printf (rf, "//GRAPH%d\n", first);
	      f_printf (rf, "%s\n", upstr);
	      f_printf (rf, "%s\n", x_str);
	    }

	  graph_identity (rf, first);

	  for (k = 0; k < 50; k++)
	    {
	      upstr[k] = 0;
	      x_str[k] = 0;
	      y_str[k] = 0;
	    }
	  first++;
	}
    }

  first = 1;
  for (i = 1; i <= numstring; i++)
    {
      sprintf (infname, "%.14s", menustr + i * 15 - 14);
      trim (infname);
      if (menustr[i * 15] == '+')
	{
	  FILE *infile = fopen (infname, "r");
	  k = 0;
	  while ((c = getc (infile)) != '\n')
	    {
	      upstr[k] = c;
	      k++;
	    }
	  k = 0;
	  while ((c = getc (infile)) != '\n')
	    {
	      x_str[k] = c;
	      k++;
	    }
	  fscanf (infile, "//X from %le to %le N_bins= %d\n", &xMin,
		  &xMax, &dim);
	  k = 0;
	  while ((c = getc (infile)) != '\n')
	    {
	      y_str[k] = c;
	      k++;
	    }
	  fscanf (infile, "//Y from %le to %le", &yMin, &yMax);
	  fscanf (infile, "//combine= %d", &combine);

	  if (first == 1)
	    {
	      f_printf (rf, "\n{\n");
	      f_printf (rf, "gROOT->Reset();\n");
	      f_printf (rf, "TCanvas *c1 = new TCanvas(\"c1\",\" \",200,100,700,500);\n");
	      f_printf (rf, "c1->SetFillColor(0);\n");
	      f_printf (rf, "c1->SetBorderMode(0);\n");
	      f_printf (rf, "c1->SetFrameBorderMode(0);\n");
	      f_printf (rf, "gStyle->SetOptTitle(kFALSE);\n\n");
	      f_printf (rf, "//c1->SetLogy(1);  //Set Log. Scale;\n\n\n");
	      if (dim != 0) dX = (xMax - xMin) / dim;
	      f_printf (rf, "double Xarray[%d];\n", dim);
	      f_printf (rf, "for(int i=0;i<%d;i++) Xarray[i]=%e+i*%e;\n\n", dim, xMin, dX);
	    }
	  f_printf (rf, "// GRAPH %d\n", first);

	  while ((getc (infile) != 'Y') ||
		 (getc (infile) != 'a') ||
		 (getc (infile) != 'r') ||
		 (getc (infile) != 'r') ||
		 (getc (infile) != 'a') ||
		 (getc (infile) != 'y'))
	    {
	    }
	  while ((c = getc (infile)) != '{')
	    {
	    }

	  f_printf (rf, "double Yarray%d[%d]={", first, dim);
	  while ((c = getc (infile)) != '}')
	      putc (c, rf);
	  fclose (infile);

	  f_printf (rf, "};\n");
	  f_printf (rf, "TGraph *gr%d = new ", first);
	  f_printf (rf, "TGraph(%d,Xarray,Yarray%d);\n", dim, first);
	  if (first == 1)
	    f_printf (rf, "TGaxis::SetMaxDigits(3);\n");
	  f_printf (rf, "gr%d->SetLineWidth(2);\n", first);
	  color = graphcolor (first);
	  f_printf (rf, "gr%d->SetLineColor(%d);\n", first, color);
	  style = graphstyle (first);
	  f_printf (rf, "gr%d->SetLineStyle(%d);\n", first, style);

	  if (first == 1)
	    {
	      sprintf (xaxistitle, "\"%s\"", x_str);
	      sprintf (yaxistitle, "\"#sigma, fb\"");
	      if (!strncmp (x_str, "//Transverse momentum Pt%d", 23))
		{
		  sprintf (xaxistitle, "\"P_{T}, GeV\"");
		  sprintf (yaxistitle, "\"d#sigma/d P_{T}, fb/%.0f GeV\"", dX);
		}

	      if (!strncmp (x_str, "//Mass", 6))
		{
		  sprintf (xaxistitle, "\"M, GeV\"");
		  sprintf (yaxistitle, "\"d#sigma/d M, fb/%.0f GeV\"", dX);
		}

	      if (!strncmp (x_str, "//Energy E", 10))
		{
		  sprintf (xaxistitle, "\"E, GeV\"");
		  sprintf (yaxistitle, "\"d#sigma/d E, fb/%.0f GeV\"", dX);
		}

	      if (!strncmp (x_str, "//Angle", 7))
		{
		  sprintf (xaxistitle, "\"#theta, deg\"");
		  sprintf (yaxistitle, "\"d#sigma/d #theta, fb/%.0f deg\"", dX);
		}

	      if (!strncmp (x_str, "//pseudo-rapidity", 17))
		{
		  sprintf (xaxistitle, "\"#eta\"");
		  sprintf (yaxistitle, "\"d#sigma/d #eta, fb\"");
		}

	      if (!strncmp (x_str, "//Rapidity", 10))
		{
		  sprintf (xaxistitle, "\"#y\"");
		  sprintf (yaxistitle, "\"d#sigma/d #y, fb\"");
		}

	      if (!strncmp (x_str, "//Cosine", 8))
		{
		  sprintf (xaxistitle, "\"cos(#theta)\"");
		  sprintf (yaxistitle, "\"d#sigma/d cos(#theta), fb\"");
		}
	      f_printf (rf, "gr1->GetXaxis()->SetTitle(%s);\n", xaxistitle);
	      f_printf (rf, "gr1->GetYaxis()->SetTitle(%s);\n", yaxistitle);

	      f_printf (rf, "gr1->SetMinimum(%e);\n", totYMin);
	      f_printf (rf, "gr1->SetMaximum(%e);\n", 1.1 * totYMax);
	      f_printf (rf, "gr1->Draw(\"AC\");\n\n");
	    }
	  else
	    {
	      f_printf (rf, "gr%d->Draw(\"C\");\n\n", first);
	    }
	  first++;
	}
    }

  f_printf (rf, "//c1->Print(\"%s.eps\");\n", outname);
  f_printf (rf, "//c1->Print(\"%s.jpg\");\n}\n", outname);
  fclose (rf);
  messanykey (10, 12, scat (" You can find results in the file\n%s", outname_C));
}


void
combine_root (void)
{
  int i, k, numstring = 0;
  int doserror;
  char f_name[STRSIZ];
  char menustr[2016];
  void *pscr2 = NULL;
  searchrec s;

  menustr[0] = 15;

  k = 1;
  strcpy (f_name, "*.C");
  doserror = find_first (f_name, &s, anyfile);
  while (doserror == 0 && k <= 2000)
    {
      for (i = 1; (i <= strlen (s.name)) && (i <= 15); i++)
	menustr[k++] = s.name[i - 1];
      for (i = strlen (s.name) + 1; i <= 15; i++)
	menustr[k++] = ' ';
      doserror = find_next (&s);
      numstring++;
    }
  menustr[k] = 0;
  if (0 == menustr[1])
    {
      messanykey (10, 15, "directory  is empty");
      return;
    }

  k = 1;
  do
    {
      menu1 (10, 10, "", menustr, "", &pscr2, &k);
      if (k > 0)
	{
	  sprintf (f_name, "%.14s", menustr + k * 15 - 14);
	  readtext (f_name);
	  if (menustr[k * 15] == ' ')
	    menustr[k * 15] = '+';
	  else
	    menustr[k * 15] = ' ';
	}
    }
  while (k != 0);
  writeroothist (menustr, numstring);
}
